function canSelectController()
   {
   return (!isSaveInProgress() && GetData("CONTROLLER_SELECTION_COMPLETE"));
   }

function SelectInitialControllerIfPossible()
   {
   urlArgs=urlArguments();
   var isFound = false;
   var controllerFocus = 0;

   if ((urlArgs.FIRST_TIME == "TRUE" || urlArgs.RESCAN == "TRUE") && numChoices == 1)
      {
      isFound = true;
      controllerFocus = option[0].focusTag;
      }

   if (urlArgs.SLOT)
      {
      for (var i=0; (i < numChoices) && !isFound; ++i)
         {
         if (option[i].slot != null)
            {
            if (option[i].slot == urlArgs.SLOT)
               {
               isFound = true;
               controllerFocus = option[i].focusTag;
               }
            }
         }
      }
   else if (urlArgs.WWN)
      {
      for (var i=0; (i < numChoices) && !isFound; ++i)
         {
         if (option[i].wwn != null)
            {
            if (option[i].wwn == urlArgs.WWN)
               {
               isFound = true;
               controllerFocus = option[i].focusTag;
               }
            }
         }
      }
   else if (urlArgs.SERIALNUMBER)
      {
      for (var i=0; (i < numChoices) && !isFound; ++i)
         {
         if (option[i].serialnumber != null)
            {
            if (option[i].serialnumber == urlArgs.SERIALNUMBER)
               {
               isFound = true;
               controllerFocus = option[i].focusTag;
               }
            }
         }
      }

   if (isFound)
      {
      HandleControllerSelectionChange(controllerFocus);
      }

   return isFound;
   }

function DisplayControllerChoices() 
 {
 document.write("<table width=100% cellspacing=0 cellpadding=0 border=0>");
 for (var i = 0; i < numChoices; ++i)
  {
  document.write("<tr><td>")
  document.write("<table id=" + option[i].focusTag + "_TABLE border=0 cellpadding=0 cellspacing=0 class=normal><tr>");
  document.write("<td align=left valign=top><IMG src='Images/top_left_trans2.gif'></td>");
  document.write("<td height=20 rowspan=2>");
  document.write("<a href='' class=controllerLink target='' TABINDEX=-1 ");
  document.write("onclick= \"HandleControllerSelectionChange('" + option[i].focusTag + "');return false;\">");
  document.write("<img border=0 src='");
  WriteCtrlImageName(option[i]);
  document.write("' width=30 height=20 align=left></a></td>");
  document.write("<td height=40 id=controllerChoiceLink rowspan=2>");
  document.write("<a href='' class=controllerLink target='' + id=" + option[i].focusTag + " ");
  document.write("onclick=\"HandleControllerSelectionChange('" + option[i].focusTag + "');return false;\">");
  document.write(InsertParmsInString(option[i].name));
  document.write("</a></td>");

  document.write("<td height=20 align=right valign=top><IMG src='Images/top_right_trans2.gif'></td>");
  document.write("</tr>");

  document.write("<tr><td height=20 align=left valign=bottom><IMG src='Images/btm_left_trans2.gif'></td><td height=20 align=right valign=bottom><IMG src='Images/btm_right_trans2.gif'></td></tr></table>");
  document.write("</tr>");

  AddKBIndex(option[i].focusTag);
  kbIdArray[option[i].focusTag].id=option[i].focusTag;
  kbIdArray[option[i].focusTag].focusElement=document.getElementById(option[i].focusTag);
  kbIdArray[option[i].focusTag].focusElement.onfocus=controllerFocus;
  kbIdArray[option[i].focusTag].focusElement.onblur=controllerBlur;
  }        
   if (numChoices == 0)
      {
      document.write("<tr><I>" + LoadString("PX_TAG_NONE") + "</I></tr>");
      }
   if (numErrors == 0)
      {
      // If there are no errors
      if (numChoices == 0)
         {
         // If there are no controllers, blank the screens and display message
         choiceFrame = GetChoiceFrame();
         choiceFrame.location = "NC-01-No.htm";
         }
      else
         {
         if (TaskDataExists("selectedController"))
            {
            selectedController=GetTaskData("selectedController");
            currentHighlightIndex=kbIdArray[selectedController].index;
            currentSelectionIndex=kbIdArray[selectedController].index;
            highlight(selectedController);
            }
         else
            {
            choiceFrame = GetChoiceFrame();
            choiceFrame.location = "NC-01.htm";
            }
         }
      }
   else
      {
      // There are errors, so we need to load the error page and blank the screen
      choiceFrame = GetChoiceFrame();
      choiceFrame.location = "NC-01-Er.htm";
      }
   document.write("</table><br>");
   }

function HandleControllerSelectionChange(focusIn)
 {
 changeController = false;
 if (canSelectController())
  {
  choiceFrame = GetChoiceFrame();
  if (choiceFrame.userTag)
   {
   document.controllerForm.TAG.value = choiceFrame.userTag;
   }
  document.controllerForm.NEW_FOCUS.value = focusIn;
  
  hasEmptyArrays = false;
  isSavePossible = false;
  configFrame = GetConfigFrame();
  TransferDataFromTo( "hasEmptyArrays",configFrame,this );
  TransferDataFromTo( "isSavePossible",configFrame,this );

 changeController = true;
 if (isSavePossible || hasEmptyArrays){changeController = confirm(discardMessage);}
 if (changeController)
  {
  SetData("CONTROLLER_SELECTION_COMPLETE",false);
  DeleteData("CONTROLLER_FOCUS_TAG");
  existingFocus = GetTaskData("selectedController");

  unhighlight(existingFocus);
  currentHighlightIndex = kbIdArray[focusIn].index;
  currentSelectionIndex = kbIdArray[focusIn].index;
  kbIdArray[focusIn].focusElement.focus();


  SetTaskData("selectedController",focusIn);

  if (isInAdvancedMode())
   {
   document.controllerForm.action="AV-Config.htm";
   document.controllerForm.target="config";
   document.controllerForm.submit();
   }
  else
   {
   document.controllerForm.action="NU-01.htm";
   document.controllerForm.target="choice";
   document.controllerForm.submit();
   }
  }
 }
 return changeController;
 }

function DisplayDiscoveryErrors()
  {
  for( var i =0; i < numErrors; ++i )
    {
    alert( error[i].name.text );
    }
  }

function ControllerRescan()
   {
   if( canSelectController() )
   {
   var isOKtoRescan = true;
   configFrame = GetConfigFrame();
   if (configFrame)
     {
      if ( configFrame.isSavePossible ||
           configFrame.hasEmptyArrays )
         {
         if ( !confirm(discardMessage) )
            {
            isOKtoRescan = false;
            }
         }
     }

   if ( isOKtoRescan )
      {
      DeleteAllTaskData();
      mainFrame = GetMainFrame();
      
      var unlockController = false;
      choiceFrame = GetChoiceFrame();
      unlockController = ( choiceFrame.focusTag != null );

      //Unlock the current controller image if necessary before doing the rescan.
      if ( unlockController )
         {
         document.rescanWithUnlockForm.TAG.value = choiceFrame.userTag;
         document.rescanWithUnlockForm.FOCUS.value = choiceFrame.focusTag;
         mainFrame.location="ACU-Main.htm";
         document.rescanWithUnlockForm.submit();
         }
      else
         {
         mainFrame.location="ACU-Main.htm";
         parent.disc.location = "CC-Init.htm?RESCAN=TRUE";
         }
      }
   }
   return false;
   }