<html>

<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="expires" content="Tue, 01 Jan 1981 01:00:00 GMT">


<head>

<script>

chpReady = false;

<!#jsdebug.js>
<!#chpnav.js>
<!#chpcooki.js>
<!#chptimer.js>


//--------------------------------------------------------------------------
// JS debug support code

debugTag = new String("<!DebugAppletConsole>");

debugOn = (0<debugTag.length);
debugOn = false;     // false =>NO DEBUG

debugWindow = null;
if(debugOn)
   debugWindow = window.open("", "CHPJSDebugWindow");

function debugOut()
{
   var i;
   var alertstring="";

   if(debugOn)
   {

      for(i=0; i<arguments.length; i++)
      {
         if(null!=debugWindow)
         {
            debugWindow.document.writeln(arguments[i]+"<br>");
         }
         else
         {
            alertstring+= (arguments[i] + "\n");
         }
      }

      if(null==debugWindow)
         alert(alertstring);
   }
}
//--------------------------------------------------------------------------

//---- some constants ----
tabs = new Array( "Home", "Settings", "Tasks", "Tools", "Logs" );
activetabs = new Array();


//----- object to contain miscellaneous CHP data ---
chpMiscData = new Object();


//----- here's the data structures for the tree ---
chpTree = new chpTreeNode( "root", null, -1 );

debugOut("location.search="+location.search);

chpRequest = "home";    //--- default
chpPage = "";

if(0<location.search.length)
{

   qsvars = location.search.substring(1).split("&");

   for(i=0; i<qsvars.length; i++)
   {
      qsvars[i] = qsvars[i].toLowerCase();   // all lc for case insensitive compares

      if(0==qsvars[i].indexOf("chppath="))
      {
         chpRequest = unescape( qsvars[i].substring( 8 ));
      }
      else if(0==qsvars[i].indexOf("chppage="))
      {
         chpPage = unescape( qsvars[i].substring( 8 ));
      }
   }
}

debugOut("location.search= "+location.search+", chpRequest= "+chpRequest+", chpPage= "+chpPage);


chpPath = chpRequest.split("::");   // break it up into the requested pieces
chpPathIndex = 0;

chpNodeContext = chpTree;

navItemStack = new Array();

oneMoreLevel = null;
nodesToExpand = new Array();

lastChunk = false;

findBadItems = (("home" == String(chpRequest).toLowerCase())&& ""==chpPage);
badItemList = new Array();

debugOut("findingBadItems:  "+findBadItems);


autorefreshPageFlag = true;   // enabled on this page



function loadNavItem( navItem )
{
   debugOut("loadNavItem: "+navItem.name+"  url:  "+navItem.url);

   if( !navItem.loaded )
   {
      loadHiddenFrame(navItem.url);
      navItem.loaded = true;
   }
   else
   {
      findNextThingToLoad();
   }
}


function showPages()
{
   var   node;
   var   i;
   var   found;

   debugOut("showPages - loading up the visible pages");

   parent.frames.CHPHiddenFrame.location.replace("/chpblank.htm");   //-- get rid of hidden frame issues

   parent.frames.CHPHeaderFrame.location.replace("/chphead.htm");

   if( "" == chpPage )
   {
      parent.frames.CHPDataFrame.location.replace("/chpdata.htm");
   }
   else
   {
      node = getPathContext( chpRequest );
      if(null!=node)
      {
         found = false;
         for(i=0;!found && i<node.dataList.length; i++)
         {
            if( chpPage.toLowerCase() == node.dataList[i].displayName().toLowerCase() )
            {
               if( ""== node.dataList[i].target || "0"==node.dataList[i].target || 0==node.dataList[i].target)
               {
                  parent.frames.CHPDataFrame.location.replace( node.dataList[i].url );
               }
               else
               {
                  chpPage = "";  //--- blank it out for nav vector
                  parent.frames.CHPHeaderFrame.location.replace("/chphead.htm"); //--- fix nav vector
                  window.open( node.dataList[i].url, node.dataList[i].target, "", true );  //--- open url in a separate window
                  parent.frames.CHPDataFrame.location.replace("/chpdata.htm");
               }
               found = true;
            }
         }

         if(!found)
         {
            debugOut("no match for "+chpPage+" found in node "+node.name);
            parent.frames.CHPDataFrame.location.replace( "Javascript:document.writeln(\"<br><h2>y[W[hɃG[܂BĎsĂB\");");
         }
      }
      else
      {
         //CBFIX
         debugOut("failed to find a node for context "+chpRequest);

         parent.frames.CHPDataFrame.location.replace( "Javascript:document.writeln(\"<br><h2>y[W[hɃG[܂BĎsĂB\");");
      }
   }

}


function findNextThingToLoad()
{
   var oneChild;
   var i;
   var needsExpansion;

   if(0!=navItemStack.length)
   {
      //--- pull the next thing in
      thisNavItem = navItemStack[navItemStack.length-1];
      navItemStack.length = navItemStack.length-1;

      debugOut("findNextThingToLoad:  loading navItem "+thisNavItem.url);

      loadNavItem( thisNavItem );
   }
   else if( chpPathIndex < chpPath.length )
   {
      // we need to find the next level of stuff
      debugOut("findNextThingToLoad:  loading next chunk "+chpPath[ chpPathIndex ]+", in context "+chpNodeContext.name);

      chpNodeContext = chpNodeContext.findNode( chpPath[ chpPathIndex ]);
      chpPathIndex++;

      if (null != chpNodeContext)
      {
         debugOut("updated node context to "+chpNodeContext.name);
      }

      if( chpPathIndex == chpPath.length)
         lastChunk = true;

      if(null==chpNodeContext)
      {
        //--- this is an error, asked for something that doesn't exist, give up
        //--- CBFIX:  add an error page display?
         debugOut("findNextThingToLoad:  no node found for "+chpPath[ chpPathIndex-1]);

         chpPathIndex = chpPath.length;
         findNextThingToLoad();     //--- to complete processing
      }
      else
      {
         for(i=0; i<chpNodeContext.navList.length; i++)
         {
            navItemStack[ navItemStack.length ] = chpNodeContext.navList[i];

            debugOut( "loading up navItemStack with "+chpNodeContext.navList[i].name+"  url:  "+chpNodeContext.navList[i].url);
         }

         findNextThingToLoad();
      }
   }
   else if (lastChunk)
   {
      debugOut("findNextThingToLoad:  last chunk!");

      lastChunk = false;   //--- clear the flag

      if(null!=chpNodeContext)
      {
         for( oneChild in chpNodeContext.children )
         {
            needsExpansion = false;

            for(i=0;!needsExpansion && i< chpNodeContext.children[ oneChild ].navList.length; i++)
            {
               needsExpansion = !chpNodeContext.children[oneChild].navList[i].loaded;
            }

            if(needsExpansion)
               nodesToExpand[nodesToExpand.length] = chpNodeContext.children[oneChild];
         }
      }

      findNextThingToLoad();
   }
   else if (0!= nodesToExpand.length)
   {
      oneNode = nodesToExpand[nodesToExpand.length-1];
      nodesToExpand.length--;

      debugOut("findNextThingToLoad:  expanding node "+oneNode.name);

      chpNodeContext = oneNode;
      debugOut("updating chpNodeContext to "+chpNodeContext.name);
      for(i=0; i<oneNode.navList.length; i++)
      {
         if(!oneNode.navList[i].loaded)
         {
            navItemStack[ navItemStack.length ] = oneNode.navList[i];

            debugOut("findNextThingToLoad:  adding navitem "+oneNode.navList[i].url+" to stack for node "+oneNode.name);
         }
      }

      findNextThingToLoad();
   }
   else
   {
      //--- we are all done, load up the UI
      debugOut("findNextThingToLoad:  all done, load pages");

      chpReady = true;
      showPages();

      arfMode();   //--- start autorefresh timer if needed

      dumpTree(chpTree);
   }
}




function PageDone()
{
   debugOut("PageDone");

   findNextThingToLoad();
}


function AddNavEntry( hmmo, entryName, entryStatus, entryURL )
{
   var rc = false;
   var splitName;

   debugOut("AddNavEntry("+hmmo+", "+entryName+", "+entryStatus+", "+entryURL+")  contextName "+chpNodeContext.name);

   resetWaitTimer();

   rc = chpNodeContext.addNav( hmmo, entryName, entryStatus, entryURL, findBadItems, nodesToExpand );

   return rc;
}


function AddDataEntry( hmmo, entryName, entryStatus, entryURL, entryTarget )
{
   var rc = false;

   debugOut("AddDataEntry( "+hmmo+", "+entryName+", "+entryStatus+", "+entryURL+", "+entryTarget+" )");

   resetWaitTimer();

   rc = chpNodeContext.addData( hmmo, entryName, entryStatus, entryURL, entryTarget, findBadItems, badItemList );

   return rc;
}


function DisableAutorefreshFlag()
{
   debugOut("DisableAutorefreshFlag");

   autorefreshPageFlag = false;
}


function systemStatus()
{
   var oneChild;

   for( oneChild in chpTree.children )
   {
      debugOut("aggregating system status from "+chpTree.status+"  with "+chpTree.children[oneChild].status+"  "+chpTree.children[oneChild].name);
      chpTree.aggregateStatus( chpTree.children[oneChild].status );
   }

   return chpTree.status;
}


function tablist()
{
   var i;

   activetabs.length = 0;

   // always have tab[0] (home) active
   activetabs[ activetabs.length ] = tabs[0];

   for(i=1; i<tabs.length; i++)
   {
      if( null != chpTree.children[ tabs[i].toLowerCase() ] )
      {
         activetabs[ activetabs.length ] = tabs[i];
      }
   }

   return activetabs;
}


function showThisPath( pathIn, pageIn )
{
   var url;

   if( pathIn == chpRequest )
   {
      debugOut("showThisPath:  just another page in the same path");

      // this is just another page on the same path
      chpPage = pageIn;
      showPages();
   }
   else
   {
      url = "/chpstrt.htm?chppath="+escape( pathIn );
      if(""!=pageIn)
         url = url + "&chppage=" + escape( pageIn );

      debugOut("showThisPath:  replacing applet frame url with "+url);

      parent.frames.CHPAppletFrame.location.replace( url );
   }
}

function autorefreshPages()
{
   var localRequest = chpRequest;

   chpRequest = "not gonna match this";

   showThisPath( localRequest, chpPage );
}


function getPathContext(pathIn)
{
   var   thisContext = chpTree;
   var   localPath;
   var   i;

   debugOut("getPathContext for "+pathIn);

   if(null==pathIn || ""==pathIn)
      pathIn = chpRequest;

   localPath = pathIn.split("::");

   for(i=0; null!=thisContext && i<localPath.length; i++)
   {
      thisContext = thisContext.findNode( localPath[i] );
   }

   return thisContext;
}


function loadHiddenFrame( pageToLoad )
{
   parent.frames.CHPHiddenFrame.location.replace(pageToLoad);
   waitOnLoad();
}


function turnOnAutorefresh()
{
   enableAutorefresh();
}

function turnOffAutorefresh()
{
   disableAutorefresh();
}

function getAutorefreshInterval()
{
   return arfinterval;
}

function setAutorefreshInterval( valueIn )
{
   if (5 > valueIn) valueIn = 5;
   if (60 < valueIn) valueIn = 60;

   setarfInterval( valueIn );
}

function autorefreshStatus()
{
   var   rc = 1;

   if(!arfenabled)
   {
      rc = 0;
   }
   else if(!autorefreshPageFlag)
   {
      rc = 2;
   }

   return rc;
}


function setProductName( prodname )
{
   chpMiscData.productName = prodname;
}


function setRIBInfo( name, link )
{
   chpMiscData.RIBName = name;
   chpMiscData.RIBLink = link;
}


</script>

</head>

<body bgcolor=#cccccc>

<script>

//startupTimer( 20, "true"==configGet("autorefreshEnabled"), configGet("autorefreshInterval"));

startupTimer( 20, false, configGet("autorefreshInterval")); // autorefresh disabled in this release

//--- do the loading page
parent.frames.CHPDataFrame.location.replace( "/chpload.htm" );

//--- start things up by loading the hidden frame with chptree.htm
loadHiddenFrame( "/chptree.htm" );

</script>


</body>

</html>
